import { GetCityPageCount } from "@/lib/graphql/Query/DestinationCityPage/DestinationCityPageCount.graphql"
import { GetCityPageUrls } from "@/lib/graphql/Query/DestinationCityPage/DestinationCityPageUrl.graphql"
import { request } from "@/lib/graphql/request"
import { createCounter } from "@/server/telemetry"

import { generateTag, generateTagsFromSystem } from "@/utils/generateTag"

import { batchedCityPageUrlsSchema, cityPageCountSchema } from "./output"

import { DestinationCityPageEnum } from "@/types/enums/destinationCityPage"
import type { System } from "@/types/requests/system"
import type {
  DestinationCityPageRefs,
  GetCityPageCountData,
  GetCityPageUrlsData,
} from "@/types/trpc/routers/contentstack/destinationCityPage"
import type { Lang } from "@/constants/languages"

export function generatePageTags(
  validatedData: DestinationCityPageRefs,
  lang: Lang
): string[] {
  const connections = getConnections(validatedData)
  return [
    // This tag is added for the city list data on country pages to invalidate the list when city page changes.
    generateTag(
      lang,
      `city_list_data:${validatedData.destination_city_page.destination_settings.city}`
    ),
    generateTagsFromSystem(lang, connections),
    generateTag(lang, validatedData.destination_city_page.system.uid),
  ].flat()
}

export function getConnections({
  destination_city_page,
}: DestinationCityPageRefs) {
  const connections: System["system"][] = [destination_city_page.system]
  if (destination_city_page.blocks) {
    destination_city_page.blocks.forEach((block) => {
      switch (block.__typename) {
        case DestinationCityPageEnum.ContentStack.blocks.Accordion: {
          if (block.accordion.length) {
            connections.push(...block.accordion)
          }
          break
        }
        case DestinationCityPageEnum.ContentStack.blocks.Content:
          {
            if (block.content.length) {
              // TS has trouble infering the filtered types
              // @ts-ignore
              connections.push(...block.content)
            }
          }
          break
      }
    })
  }
  if (destination_city_page.sidepeek_content) {
    destination_city_page.sidepeek_content.content.embedded_itemsConnection.edges.forEach(
      ({ node }) => {
        connections.push(node.system)
      }
    )
  }

  return connections
}

export async function getCityPageCount(lang: Lang) {
  const getCityPageCountCounter = createCounter(
    "trpc.contentstack",
    "cityPageCount.get"
  )
  const metricsGetCityPageCount = getCityPageCountCounter.init({ lang })

  metricsGetCityPageCount.start()

  const response = await request<GetCityPageCountData>(
    GetCityPageCount,
    {
      locale: lang,
    },
    {
      key: `${lang}:city_page_count`,
      ttl: "max",
    }
  )

  if (!response.data) {
    metricsGetCityPageCount.dataError(
      `Failed to get city pages count for ${lang}`
    )
    return 0
  }

  const validatedResponse = cityPageCountSchema.safeParse(response.data)

  if (!validatedResponse.success) {
    metricsGetCityPageCount.validationError(validatedResponse.error)
    return 0
  }

  metricsGetCityPageCount.success()

  return validatedResponse.data
}

export async function getCityPageUrls(lang: Lang) {
  const getCityPageUrlsCounter = createCounter(
    "trpc.contentstack",
    "cityPageUrls.get"
  )
  const metricsGetCityPageUrls = getCityPageUrlsCounter.init({ lang })

  metricsGetCityPageUrls.start()

  const count = await getCityPageCount(lang)

  if (count === 0) {
    return []
  }

  // Calculating the amount of requests needed to fetch all pages.
  // Contentstack has a limit of 100 items per request.
  // So we need to make multiple requests to fetch urls to all pages.
  // The `batchRequest` function is not working here, because the arrayMerge is
  // used for other purposes.
  const amountOfRequests = Math.ceil(count / 100)

  const batchedResponse = await Promise.all(
    Array.from({ length: amountOfRequests }).map((_, i) =>
      request<GetCityPageUrlsData>(
        GetCityPageUrls,
        { locale: lang, skip: i * 100 },
        { key: `${lang}:city_page_urls_batch_${i}`, ttl: "max" }
      )
    )
  )
  const validatedResponse = batchedCityPageUrlsSchema.safeParse(batchedResponse)

  if (!validatedResponse.success) {
    metricsGetCityPageUrls.validationError(validatedResponse.error)
    return []
  }

  metricsGetCityPageUrls.success()

  return validatedResponse.data
}
